new;
library garchtst newton optmum;   /* test routines and optimization libraries */
dlibrary -a newgarch;             /* Open "C" library */


sel_opt=1;			@ 0: Use optmum in GAUSS, 1: Use Newtons algorithm @
sel_scale=1;		@ 1: Scale to unit, 2:Scale user defined, other#: No scale @
sel_test=1;			@ 1: Compute test routines, other#: Not @

forecast = 0;	@ save last 0 observations for forcasts @ 
diff 	 = 0;	@ first diff: 1 if used, 0 otherwise @
selday   = 0;	@ dummies: 1 if present, 0 otherwise @


Series="sp500";
plin=0|1|2;

alfa0= 4.8e-006;
alfa = 0.14;
beta = 0.82;

	       /*--------------- FILE PARAMETERS ---------------*/

garchtype="_GARCH" $+ ftos(rows(beta),"%*.*lf",1,0) $+ ftos(rows(alfa),"%*.*lf",1,0);

baseDIR= "c:\\wingauss\\mydir";
savefile = baseDIR $+ "\\" $+ Series $+ garchtype $+ ".txt";
saveresid= baseDIR $+ "\\" $+ Series $+ garchtype;


{input,dum,dummies}=getData2(diff,savefile,Series,selday,forecast);     /* Load data into system */


	    /*-------------- OPTIMIZATION PARAMETERS ---------------*/

prec=0.000001;         /* Set precision for parmeter estimate */


	       /*-------------- TEST PARAMETERS ---------------*/

serlag=3;			@ choose lag of serial dependence test @

/*----------------------------------------------------------------------------*/
/*------------------------ END OF USER SPECIFICATION -------------------------*/
/*----------------------------------------------------------------------------*/



/*--------------------- Define some model parameters ------------------------*/

plin=sortc(plin,1);              /* Precautionary sorting. */
p=maxc(plin);

/*---------------------------- Linear AR matrix -----------------------------*/  
IF plin[1]==0;     /* This condition checks whether a constant is present */
    ARL=ones(rows(input)-p,1);
    i=2;
ELSE;
    ARL=input[1+p-plin[1]:rows(input)-plin[1]];
    i=2;
ENDIF;

do until i > rows(plin);
    ARL=ARL~input[1+p-plin[i]:rows(input)-plin[i]];
    i=i+1;
endo;


/*------------------------------- Adjusting Y -------------------------------*/
Y=input[1+p:rows(input)];
If scalmiss(dum)==0;
    Dummies=Dummies[1+p:rows(Dummies),.];
endif;

/*------------------------- Model information needed ------------------------*/
insize=zeros(5,1);

insize[1]=rows(dum);              /* sizeDummies */
insize[2]=cols(ARL);              /* sizeLinerar mean */
insize[4]=rows(alfa);             /* sizeAlfa variance GARCH(alfa,beta) */
insize[5]=rows(beta);             /* sizeBeta variance */

sizeo=insize[1]+insize[2];
sizea=insize[4];
sizeb=insize[5];
sizee=1+insize[4]+insize[5];

/*-------------------- Initialvalues for the estimation ---------------------*/
ARDL=Dummies~ARL;
menpar=invpd(ARDL'ARDL)*ARDL'Y;            /* Initialvalues for mean */
ssr=y-ARDL*menpar;

/*
{alfa0,alfa,beta}=inigarch(ssr,5);
*/

varpar=alfa0|alfa|beta;          

start=menpar|varpar;

/*	Choose how to scale the parametervalues */
if sel_scale==1;						@ Scale to unity. @
	use_scale=1/start;			
elseif sel_scale==2;					@ User defined scale. @
	if rows(start) ne rows(use_scale);
		print " ";
		print "The # of modelparameters and # of scaleparameters differs!";
		print "Take care of this problem in the initialization.";
		stop; 
	endif; 
else;									@ No scale. @
	use_scale=ones(rows(start),1);
endif;									@ Do the scaleing. @

start=start.*use_scale;	

/* Transform for positive variance parameters */
start[sizeo+1:sizeo+2]            =start[sizeo+1:sizeo+2].^0.5;
start[sizeo+1+sizea+1:sizeo+sizee]=start[sizeo+1+sizea+1:sizeo+sizee].^0.5;


namevec=parnames(plin,dum,alfa,beta);      /* Define the names of the parameters to estimate */


/*---------------------- Carry out the esitmation ---------------------------*/

if sel_opt==0;
    _opparnm=namevec;
      _optol=prec;
    {x,f,dl,retcode}=optmum(&likgaG,start);		/* Optization */
elseif sel_opt==1;
    _parnm=namevec;								/* Create vector for parameternames */
      _tol=prec;								/* Select the tolerance */
    {x,f,dl,d2l,tot}=Newton(&likgaG,&hcoga,start);
else;
    print " ";
    print "You must choose an optimization algorithm...";
    end;
endif;

/*------------------ Untransform the estimated parameters.------------------*/
									  

@ Transform => initial and estimated parametervalues. @
    x[sizeo+1:sizeo+2]                =x[sizeo+1:sizeo+2].^2;
    x[sizeo+1+sizea+1:sizeo+sizee]    =x[sizeo+1+sizea+1:sizeo+sizee].^2;
start[sizeo+1:sizeo+2]            =start[sizeo+1:sizeo+2].^2;
start[sizeo+1+sizea+1:sizeo+sizee]=start[sizeo+1+sizea+1:sizeo+sizee].^2;

x		=x    ./use_scale;
start	=start./use_scale;

/*---------------------------------------------------------------------------*/

{dl,hessian}=finhess(x);              /* Compute the hessian without transformation */


output file=^savefile on;             /* Open output file */
/*----------- Computing for inference of the estimated parameters -----------*/
covar=inv(-hessian);
hhh=zeros(rows(x),rows(x));
hd=diag(covar);
ett=ones(rows(x),1);
hdi=ett./hd;
hdinv=diagrv(hhh,hdi);
hdinv=sqrt(hdinv);
correl=hdinv*covar*hdinv;             /* The correlation matrix */

xvar=diag(covar);
ttest=x./sqrt(xvar);
tprob=2*cdftc(abs(ttest),rows(ARL)-rows(x));  /* Double sided test */
estimate=start~x~sqrt(xvar)~ttest~tprob;


/*--------------- Print the estimated model and its inference ---------------*/
print " ";
print "The estimated parameters of the GARCH model.";
print " ";
print "            Initial       Estimated       Std dev        t-test      p-value";
mask=ones(1,6);
mask[1]=0;
let fmt[6,3] =
           "-*.*s " 6 6  
           "*.*le " 14 4 
           "*.*le " 14 4
           "*.*le " 14 4
           "*.*lf " 12 6
           "*.*lf " 12 6;
out=namevec~estimate;
k=printfm(out,mask,fmt);


If sel_test==1;
ARDL=dummies~ARL;

/*---------------- Test of the cond. variance specification. --------------*/
print " ";
/*
meanSERI(x,insize,Y,ARDL,4);

  meanPC(x,insize,Y,ARDL,1);
  meanPC(x,insize,Y,ARDL,2);
  meanPC(x,insize,Y,ARDL,3);

  meanNL(x,insize,Y,ARDL,plin,4,1);
  meanNL(x,insize,Y,ARDL,plin,4,2);
  meanNL(x,insize,Y,ARDL,plin,4,3);
*/
print " ";
/*---------------- Test of the cond. variance specification. --------------*/
print " ";
print "-------------- Tests against remaining serial dependence ------------";
print " ";
 serARCH(x,insize,Y,ARDL,serlag);
serLiMak(x,insize,Y,ARDL,serlag);
  serADD(x,insize,Y,ARDL,serlag);

print "--------------- Tests against remaining nonlinearities --------------";
print " ";
  nonGJR(x,insize,Y,ARDL);
nonDelay(x,insize,Y,ARDL,3);
nonSignB(x,insize,Y,ARDL);

print "-------------------- Tests of parameter constancy -------------------";
print " ";
 parcons(x,insize,Y,ARDL,1);
 parcons(x,insize,Y,ARDL,2);
 parcons(x,insize,Y,ARDL,3);
print " ";
   chu95(x,insize,Y,ARDL);

print "---------------------------------------------------------------------";
endif;

/*------------------- Compute the (standardized) residuals ------------------*/
stdres=residual(x); 
save ^saveresid=stdres;


     
output off;                    /* Close output file */
dlibrary -d;                   /* Close "C" library */

end;


/*---------------------------------------------------------------------------*/
/*------------------------------ Procedures ---------------------------------*/
/*---------------------------------------------------------------------------*/

PROC(1)=likgaG(in);
LOCAL temp,j,prod,F,indrest,STAR,residual,betaD,betaL,betaN,betaDL;
LOCAL g,c,sizeD,sizeL,sizeN,sizeA,sizeB,var,likeli,Nonpart,u;
LOCAL maxab,const,presamp,u2,ARDL;

sizeD=insize[1];                   /* Identify size of model parameters */
sizeL=insize[2];
sizeA=insize[4];
sizeB=insize[5];

in[sizeo+1:sizeo+2]				=in[sizeo+1:sizeo+2].^2;
in[sizeo+1+sizea+1:sizeo+sizee]	=in[sizeo+1+sizea+1:sizeo+sizee].^2;
in								=in./use_scale;


const=in[sizeD+sizeL+1];       /* Relevant GARCH-parameters */
 alfa=in[sizeD+sizeL+2:sizeD+sizeL+1+sizeA];
 beta=in[sizeD+sizeL+1+sizeA+1:sizeD+sizeL+1+sizeA+sizeB];
                     
ARDL=Dummies~ARL;
betaDL=in[1:sizeD+sizeL];
u=Y-ARDL*betaDL;         

     /* Calculate conditional variance */
presamp=u'u/rows(u);   /* Pre-sample values for u^2 and g */

u2=u.^2;

maxab=maxc(sizeA|sizeB);

g=zeros(rows(u),1);

i=1;                            /* index for the first observation, i.e. t>0 */
do until i > rows(u);
    g[i]=const; 
    j=1;
    do until j > maxab; 
       
        if j <=sizeA;			/* Alfa case */
            if i-j > 0;
                g[i]=g[i]+alfa[j]*u2[i-j];
            else;
                g[i]=g[i]+alfa[j]*presamp;
            endif;
        endif;

        if j <=sizeB;           /* Beta case */
            if i-j > 0;
                g[i]=g[i]+beta[j]*g[i-j];
            else;
                g[i]=g[i]+beta[j]*presamp;
            endif;
        endif;       

        j=j+1;
    endo;
    i=i+1; 
endo;

retp(-sumc(-0.5*( (u2 ./ g) + ln(g) )));    /* returning the residuals for the whole model */
ENDP;

/*---------------------------------------------------------------------------*/
PROC(2)=hcoga(in);
LOCAL initial,u,g,z,ARDL,meanGRAD,meanHESS,ett,i;
LOCAL sizeD,sizeL,sizeN,sizeA,sizeB,const,alfa,beta,premult,postadd,indll;
LOCAL sizeo,sizee,elements;


sizeD=insize[1];                   /* Identify size of model parameters */
sizeL=insize[2];
sizeA=insize[4];
sizeB=insize[5];

sizeo=sizeD+sizeL;
sizee=1+sizea+sizeb;

indll								=in;  
indll[sizeo+1:sizeo+2]				=in[sizeo+1:sizeo+2].^2;
indll[sizeo+1+sizea+1:sizeo+sizee]	=in[sizeo+1+sizea+1:sizeo+sizee].^2;
indll								=indll./use_scale;


ARDL=Dummies~ARL;

initial=rows(ARDL)|sizeo|sizeA|sizeB;
meanGRAD=zeros(1,sizeo+sizee);  
meanHESS=zeros(sizeo+sizee,sizeo+sizee);

dllcall  _hcoga(initial,indll,ARDL,Y,meanGRAD,meanHESS);


/*	Adjust for the squared terms	=>	 ensure positive values 
	Adjust for the scaling			=>	 faster convergence */

premult=diagrv(zeros(rows(in),rows(in)),1./use_scale);
postadd= zeros(rows(in),rows(in));

elements=sizeo+1|sizeo+2|sizeo+1+sizea+seqa(1,1,sizeb);

i=1;		
do until i > rows(elements);
    /* Construct dY/dX:	*/
    premult[elements[i],elements[i]]=premult[elements[i],elements[i]]*2*in[elements[i]];
    /* Construct derivative of vec((df/dY)*(dY/dX)) with respect to X */
    postadd[elements[i],elements[i]]=2*meanGRAD[elements[i]]./use_scale[elements[i]];
    i=i+1;
endo;


meanGRAD=meanGRAD*premult;
meanHESS=premult*meanHESS*premult+postadd;

retp(-meanGRAD,-meanHESS);     /* We want to minimize instead of maximize */
endp;


/*---------------------------------------------------------------------------*/
PROC(2)=finhess(in);
LOCAL initial,u,g,z,ARDL,meanGRAD,meanHESS,ett;
LOCAL sizeD,sizeL,sizeN,sizeA,sizeB,const,alfa,beta,premult,postadd,indll;

sizeD=insize[1];                   /* Identify size of model parameters */
sizeL=insize[2];
sizeA=insize[4];
sizeB=insize[5];
const=in[sizeD+sizeL+1];  /* Relevant model parameters */
 alfa=in[sizeD+sizeL+2:sizeD+sizeL+1+sizeA];
 beta=in[sizeD+sizeL+1+sizeA+1:sizeD+sizeL+1+sizeA+sizeB];

ARDL=Dummies~ARL;

initial=rows(ARL)|sizeD+sizeL|sizeA|sizeB;
meanGRAD=zeros(1,sizeD+sizeL+1+sizeA+sizeB);  
meanHESS=zeros(sizeD+sizeL+1+sizeA+sizeB,sizeD+sizeL+1+sizeA+sizeB);

dllcall  _hcoga(initial,in,ARDL,Y,meanGRAD,meanHESS);

retp(meanGRAD,meanHESS);     
endp;


/*---------------------------------------------------------------------------*/
PROC(1)=parnames(plin,dum,alfa,beta);
LOCAL namevec,j,lintemp,nontemp;

lintemp=(0$+"ar("$+ftocv(plin,1,0)$+")"); /* Linear parameternames. */

namevec=dum|lintemp|"alfa0"|(0$+"alfa"$+ftocv(seqa(1,1,rows(alfa)),1,0));
namevec=namevec|(0$+"beta"$+ftocv(seqa(1,1,rows(beta)),1,0));

RETP(namevec);
ENDP; 


/*---------------------------------------------------------------------------*/
PROC(1)=residual(in);
LOCAL temp,j,prod,F,indrest,STAR,residual,betaD,betaL,betaN,betaDL;
LOCAL g,c,sizeD,sizeL,sizeN,sizeA,sizeB,var,likeli,Nonpart,u;
LOCAL maxab,const,presamp,u2,ARDL;

sizeD=insize[1];                   /* Identify size of model parameters */
sizeL=insize[2];
sizeA=insize[4];
sizeB=insize[5];

const=in[sizeD+sizeL+1];       /* Relevant GARCH-parameters */
 alfa=in[sizeD+sizeL+2:sizeD+sizeL+1+sizeA];
 beta=in[sizeD+sizeL+1+sizeA+1:sizeD+sizeL+1+sizeA+sizeB];
                     
ARDL=Dummies~ARL;
betaDL=in[1:sizeD+sizeL];
u=Y-ARDL*betaDL;         

     /* Calculate conditional variance */
presamp=u'u/rows(u);   /* Pre-sample values for u^2 and g */

u2=u.^2;

maxab=maxc(sizeA|sizeB);

g=zeros(rows(u),1);

i=1;                            /* index for the first observation, i.e. t>0 */
do until i > rows(u);
    g[i]=const; 
    j=1;
    do until j > maxab; 
       
        if j <=sizeA;			/* Alfa case */
            if i-j > 0;
                g[i]=g[i]+alfa[j]*u2[i-j];
            else;
                g[i]=g[i]+alfa[j]*presamp;
            endif;
        endif;

        if j <=sizeB;           /* Beta case */
            if i-j > 0;
                g[i]=g[i]+beta[j]*g[i-j];
            else;
                g[i]=g[i]+beta[j]*presamp;
            endif;
        endif;       

        j=j+1;
    endo;
    i=i+1; 
endo;

retp(u./sqrt(g));    /* returning the residuals for the whole model */
ENDP;



/*---------------------------------------------------------------------------*/
/*----------------------- Start values for GARCH(1,1) -----------------------*/
/*---------------------------------------------------------------------------*/
/* Assume that u is the residual from the mean model */
proc(3)=inigarch(u,lag);
LOCAL alfa0,alfa,Beta,corr,corr1,t,apb,fval;


corr=acf(u.^2,lag);              /* Needs the autocorrelation function */
corr1=corr[2,1];
corr=corr./corr[2,1];
corr=trimr(corr,2,0);

t=seqa(1,1,lag-1);                /* time sequense used for (alfa+beta)^t */
corr=log(corr);                   /* exponential dependence, corr(t+1)/corr(1)=(alfa+beta)^t */
p=inv(t't)*t'corr;                /* OLS */
apb=exp(p);                       /* estimate of (alfa+beta) */

print apb;

if abs(apb) >= 1;                /* if (alfa+beta)>= 1 the variance could be negative, */
    apb=0.99;                    /* avoid this problem. */
    print "(alfa+beta)>= 1";
else;
    apb=abs(apb);
endif;

alfa0=(1-apb)*(stdc(u)^2);        /* estimate of alfa0 */

fval=(apb^2-2*apb*corr1+1)/(apb-corr1); 
beta=fval/2-sqrt(fval^2/4-1);    /* solve for estimate of beta */

alfa=apb-beta;                   /* esitmate of alfa based of estimate of beta */


retp(abs(alfa0),abs(alfa),abs(beta));
endp;


/*---------------------------------------------------------------------------*/
proc(1)=acf(in,lag);
local matr,i,cor;

matr={};
i=0;
do until i > lag;
   matr=matr~trimr(in,i,lag-i);
   i=i+1;
endo;
cor=corrx(matr);

retp(cor[1,.]');
endp;






