                           /* File: getData2.G */

proc(3)=getData2(diff,savefile,xrate,selday,forecast);
local ind,input,i,y,temp;
local dataset,alldata,varname,names,day,daycheck,nameDum,Dummies;
local data, baseDIR,f1,x;

	       /*--------------- What to read ---------------*/
 


baseDIR= "c:\\wingauss\\data";
dataset= baseDIR $+ "\\" $+ xrate;

                               

if selday==0;
	names = xrate;
	daycheck = {}; 
else;             
	names = "day";
	names=names|xrate;  
	daycheck = 1;            
endif;

                /*------------ Data reading ----------*/

{ varname,ind }=indices(dataset,names);        /* Loading data */
open f1=^dataset;
alldata={};
do until eof(f1);
    x=readr(f1,1000);
    alldata=alldata|x;
endo;
f1=close(f1);
input=alldata[.,ind];
input=trimr(input,0,forecast);  /* Save observations to be able to do forcasts */ 

               /*------------- Daily dummies --------------*/

IF scalmiss(daycheck)==0;                 /* Create dummy matrix if daily data */
	day="day";
    ind=indnv(day,names);                 /* Index of the day vector */
    nameDum="Mo"|"Tu"|"We"|"Th"|"Hol";
    Dummies=zeros(rows(input),rows(nameDum));
    i=1;
    do until i > rows(input);
        if      input[i,ind]==1; Dummies[i,1]=1;
        elseif  input[i,ind]==2; Dummies[i,2]=1;
        elseif  input[i,ind]==3; Dummies[i,3]=1;
        elseif  input[i,ind]==4; Dummies[i,4]=1;
        elseif  input[i,ind]==6; Dummies[i,5]=1;
        endif;
        i=i+1;
    endo;
ELSE;
    Dummies={};
    nameDum={};
ENDIF;

        /*-------------- Adjusting the excange rate --------------*/

                         /* For indnv only */
ind=indnv(xrate,names);  /* Index of excange rate vector */
data=input[.,ind];       /* Only one xrate in data set */

if diff==1;
       /*------------------- Taking first differences ------------*/

	y=trimr(ln(data),1,0)-trimr(ln(data),0,1);   /* First differences */

	IF scalmiss(daycheck)==0;           /* IF dummies... */
	    Dummies=trimr(Dummies,1,0);     /* Adjust them by assuming xrate at market close. */
	endif;

else;
	y=data;
endif;
       /*--------------- Take care of outputfile -----------*/

outwidth 256;                     /* Clear the output file and define the */
output file=^savefile reset;      /* the width of it. */

temp=date;
format /re 4,0;
print "Date (YYYY MM DD)       : " $ftocv(temp[1],4,0);;
format 2,0;
print $ftocv(temp[2],2,0) $ftocv(temp[3],2,0);
format /lo 8,1;
print "Datasheet               : " $dataset;
print "Variable(s)             : " $varname';
format /rd 4,0;
print "# obs in dataset        : " rows(y)+forecast;
print "# obs USED in dataset   : " rows(y);
print " ";

output off;

retp(y,nameDum,dummies);
endp;








